#!/usr/bin/perl
require '../web-lib.pl';
&init_config();  &HB;
&ReadParse();    %in = %config unless %in;

&header("System Info", "", undef, 1, 1, undef, &controls(), ($in{'R'}+0 ? "<meta http-equiv=refresh content=$in{'R'}>": '' ).qq(
<style type="text/css"><!--
.b {
    background-color: #ccc;
    text-decoration: none; }
--></style>) );

print "<hr>", tableHeader(3, "CPU", "c"); #implies dual CPU, no more
if( $in{'c'} ){
    $i=0;
    open(IN, "/proc/cpuinfo");
    while(<IN>){
	if( /^$/ ){
	    $i++; $j = 0; next; }
	($label, $value) = split(':');
	$label =~ s/\s+//;
	$label[$j] = $label;
	$cpu[$i][$j++] = $value;
    }
    close(IN);
    for($i=0;$i<scalar @label;$i++){
	print "<tr><td $hb valign=top><tt>$label[$i]</tt></td><td><tt>$cpu[0][$i]</tt></td><td><tt>$cpu[1][$i]</tt></td></tr>"; }
}
print "</table>";

print tableHeader(7, "Memory", "m");
if( $in{'m'} ){
    open(IN, "/proc/meminfo");
    @F = split(/:/, <IN>);
    unshift @F, ''; pop @F;
    print "<tr $hb>\n", map("<td><tt>$_</tt></td>", @F ), "\n</tr>";
    @F = split(/\s+/, <IN>);
    print "<tr>\n", map("<td align=right><tt>$_</tt></td>", @F ), "\n</tr>";
    @F = split(/\s+/, <IN>);
    print "<tr>\n", map("<td align=right><tt>$_</tt></td>", @F ), "\n</tr>";
    close(IN);
}
print "</table>";

print tableHeader(10, "Network", "n");
if( $in{'n'} ){
    open(IN, "/proc/net/dev"); <IN>; <IN>;
    print qq(<tr $hb>
<td></td><td><tt>Interface</tt></td><td><tt>Bytes</tt></td><td><tt>Packets</tt></td><td><tt>Errors</tt></td><td><tt>Dropped</tt></td><td><tt>FIFO</tt></td><td><tt>Frame</tt></td><td><tt>Compressed</tt></td><td><tt>Multicast</tt></td>
</tr>);
    while(<IN>){
	s/^\s+//;
	@F = split(/[\s:]+/, $_);
	@G = ($F[0], splice(@F,9));
	@F = splice(@F,0,9);
	print "<tr>\n", q(<td bgcolor="#c040c0">RX</td>), map("<td align=right><tt>$_</tt></td>", @F), "\n</tr>";
	push @Gtext, qq(<tr>\n<td bgcolor="#40c0c0">TX</td>). join('', map("<td align=right><tt>$_</tt></td>", @G)). "\n</tr>";
    }
    print "</tr>\n<tr></tr>\n@Gtext";
    close(IN);
}
print "</table>";

if( $in{'u'} || $in{'w'} ){
    @F = `w`; $F = shift @F; }

print tableHeader(1, "Uptime", "u");
if( $in{'u'} ){\
    print "<td><tt>$F</tt></td></tr>\n"; }
print "</table>";

print tableHeader(8, "Who", "w");
if( $in{'w'} ){
    print "<tr $hb>\n", map("<td><tt>$_</tt></td>", split(/\s+/, shift(@F), 8)), "\n</tr>";
    foreach (@F){
    s/(Mon|Tue|Wed|Thu|Fri|Sat|Sun|Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) /$1&nbsp;/;
	print "<tr>\n", map("<td align=right><tt>$_</tt></td>", split(/\s+/, $_, 8)), "</tr>"; }
}
print "</table><p>\n";
print "<center>Developed by <a href='http://www.pthbb.org/'>Jerrad Pierce</a> for <a href='http://www.networkengines.com/'>NEI</a></center>\n";
print "<hr>\n";
&footer("/", $text{'index'});
#EOOutput


sub HB {
    $tb =~ m/#(..)(..)(..)/; $tb{'r'} = $1; $tb{'g'} = $2; $tb{'b'} = $3;
    $cb =~ m/#(..)(..)(..)/; $cb{'r'} = $1; $cb{'g'} = $2; $cb{'b'} = $3;
    $hb{'r'}=int((hex($cb{'r'})+hex($tb{'r'}))/2);
    $hb{'g'}=int((hex($cb{'g'})+hex($tb{'g'}))/2);
    $hb{'b'}=int((hex($cb{'b'})+hex($tb{'b'}))/2);
    @hex = (0..10, 'A', 'B', 'C', 'D', 'E', 'F');
    foreach $key (keys %hb){
	$_ = $hb{$key};
	$one = $hex[($_%16)];
	$ten = $hex[($_-($_%16))/16];
	$hb{$key}="$ten$one"; }
    $hb = qq(bgcolor="#$hb{'r'}$hb{'g'}$hb{'b'}");
}

sub controls {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time);
	$year+=1900;
	$mon  = ++$mon < 10 ? "0$mon"  : $mon;
	$mday = $mday  < 10 ? "0$mday" : $mday;
	$min  = $min   < 10 ? "0$min"  : $min;
	$sec  = $sec   < 10 ? "0$sec"  : $sec;
	$str  = qq($year.$mon.$mday<br>\n$hour:$min:$sec&nbsp;UTC);

	$str .= "<br>\nRefresh Rate:\n";
	$refresh = loopy('R');

	foreach (unique (sort ("00", 30, 60, 90, $config{'R'}) ) ){
		next if $_ == $in{'R'};
		$str.=qq( <a href="?$refresh).qq(R=$_">$_</a>); }
	return "$str";
}

sub loopy{
    undef $_;
    foreach $k (keys %in){
	next if $k eq $_[0];
	$_ .= "$k=$in{$k}&"; }
    return $_;
}

sub tableHeader {
    my $link;
    $button = $in{$_[2]} ? '^' : 'V';
    $link = &loopy($_[2]). "$_[2]=" . ($in{$_[2]} ? 0 : 1);
    return qq(
<p><table border $cb width=750><tr>
<td $tb colspan=$_[0]><table width="100%" border=0 cellspacing=0 cellpadding=0><tr>
	<td><a name="#$_[2]">$_[1]</a></td>
	<td align=right><tt><a href="?$link#$_[2]" class=b>&nbsp;$button&nbsp;</a></tt></td></tr></table></td>
</tr>);
}
